
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

#define BYTEn(x, n) (*((char*)&(x)+n))
#define BYTE1(x) BYTEn(x, 1) // byte 1 (counting from 0)

#undef LOBYTE
#undef HIBYTE
#define LOBYTE(x) (*((char*)&(x))) // low byte
#define HIBYTE(x) (*((char*)&(x)+1))


// rotate left
static int __ROL__(int value, unsigned int count)
{
  const unsigned int nbits = sizeof(int) * 8;
  int high;
  count %= nbits;

  high = value >> (nbits - count);
  value <<= count;
  value |= high;
  return value;
}

// rotate right
static int __ROR__(int value, unsigned int count)
{
  const unsigned int nbits = sizeof(int) * 8;
  int low;
  count %= nbits;

  low = value << (nbits - count);
  value >>= count;
  value |= low;
  return value;
}

int PSnd_Playlist_Magic = 1684951888;

int LoadPlaylist(HANDLE hFile)
{
    int v5; // eax@26
    char SoundName[260]; // [sp+Ch] [bp-228h]@20
    int v7; // [sp+107h] [bp-12Dh]@26
    char FileName[260]; // [sp+10Ch] [bp-128h]@22
    unsigned int v9; // [sp+210h] [bp-24h]@23
    int v10; // [sp+214h] [bp-20h]@24
    int v11; // [sp+21Ch] [bp-18h]@26
    int v13; // [sp+224h] [bp-10h]@26
    WPARAM Buffer; // [sp+22Ch] [bp-8h]@5
    DWORD NumberOfBytesRead; // [sp+230h] [bp-4h]@5
    int a1 = 0, a2 = 1;
    LONG DistanceToMoveHigh = 0;


    SetFilePointer(hFile, 0, &DistanceToMoveHigh, FILE_BEGIN);

    ReadFile(hFile, &Buffer, 4u, &NumberOfBytesRead, NULL);
    if ( NumberOfBytesRead != 4 || Buffer != PSnd_Playlist_Magic )
        return 1;

    ReadFile(hFile, &Buffer, 4u, &NumberOfBytesRead, NULL);
    if ( NumberOfBytesRead != 4 || Buffer != 1 )
        return 1;

    ReadFile(hFile, &Buffer, 4u, &NumberOfBytesRead, NULL);
    if ( NumberOfBytesRead != 4 || !Buffer )
        return 1;

    for ( unsigned int i = 0; i < Buffer; ++i )
    {
        LOBYTE(a1) = 0;
        ReadFile(hFile, &a1, 1u, &NumberOfBytesRead, NULL);
        if ( NumberOfBytesRead != 1 )
            return 1;

        LOBYTE(a2) = a1;
        ReadFile(hFile, SoundName, (unsigned __int8)a1, &NumberOfBytesRead, NULL);
        if ( NumberOfBytesRead != (unsigned __int8)a1 )
            return 1;

        SoundName[(unsigned __int8)a1] = 0;
        ReadFile(hFile, &a1, 1u, &NumberOfBytesRead, NULL);
        if ( NumberOfBytesRead != 1 )
            return 1;

        LOBYTE(a2) = a1 + a2;
        ReadFile(hFile, FileName, (unsigned __int8)a1, &NumberOfBytesRead, NULL);
        if ( NumberOfBytesRead != (unsigned __int8)a1 )
            return 1;

        FileName[(unsigned __int8)a1] = 0;
        ReadFile(hFile, &v9, 4u, &NumberOfBytesRead, NULL);
        if ( NumberOfBytesRead != 4 )
            return 1;

        ReadFile(hFile, &v10, 1u, &NumberOfBytesRead, NULL);
        if ( NumberOfBytesRead != 1 )
            return 1;

        ReadFile(hFile, (char *)&v10 + 1, 4u, &NumberOfBytesRead, NULL);
        if ( NumberOfBytesRead != 4 )
            return 1;

        v13 = v9;
        v11 = *(int *)((char *)&v7 + (unsigned __int8)a1);
        v5 = __ROR__(~v9, a2);
        v13 = (v11 ^ v5) - i;
        v9 = (v11 ^ v5) - i;

        printf("\"%s\" \"%s\" %i %i %i\n", SoundName, FileName, v13, v10, *(int *)((char *)&v10 + 1));
    }

  return 0;
}

int WeirdValue; // globals init to 0

int AugmentWeirdValue(void)
{
  WeirdValue = 214013 * WeirdValue + 2531011;
  return (WeirdValue >> 16) & 0x7FFF;
}

int SavePlaylist(HANDLE hFile, unsigned int PlaylistSize, HWND hWnd)
{
  WPARAM v1; // edi@1
  LPCVOID v5; // ebx@10
  char v6; // kr00_1@11
  char v7; // kr04_1@11
  int v8; // edi@12
  int v10; // eax@13
  LPARAM lParam; // [sp+Ch] [bp-48h]@9
  LPCVOID lpBuffer; // [sp+2Ch] [bp-28h]@10
  int v15; // [sp+38h] [bp-1Ch]@13
  unsigned int v17; // [sp+40h] [bp-14h]@13

  int Buffer; // [sp+48h] [bp-Ch]@8
  DWORD NumberOfBytesWritten; // [sp+4Ch] [bp-8h]@8
  char v21; // [sp+53h] [bp-1h]@11
  int a1 = 1;

  v1 = 0;

  // hFile = CreateFileA(FileName, 0x40000000u, 0, 0, 2u, 0, 0);
  if ( hFile == INVALID_HANDLE_VALUE )
  {
   // MessageBoxA(MasterWindow, "Could not create the file.", 0, 0x10u);
    return 0;
  }

  Buffer = PSnd_Playlist_Magic;
  WriteFile(hFile, &Buffer, 4u, &NumberOfBytesWritten, 0);
  Buffer = 1;
  WriteFile(hFile, &Buffer, 4u, &NumberOfBytesWritten, 0);
  Buffer = PlaylistSize;
  WriteFile(hFile, &Buffer, 4u, &NumberOfBytesWritten, 0);

  for ( unsigned int i = 0; i < PlaylistSize; ++i )
  {
    lParam = 4;

    if ( SendMessageA(hWnd, 0x1005u, v1, (LPARAM)&lParam) )
    {
      v5 = lpBuffer;
      if ( lpBuffer != (LPCVOID)v1 )
      {
        v6 = strlen((const char *)lpBuffer);
        LOBYTE(a1) = v6 - 1;
        v21 = v6 - 1;
        WriteFile(hFile, &a1, 1u, &NumberOfBytesWritten, 0);
        WriteFile(hFile, v5, (unsigned __int8)a1, &NumberOfBytesWritten, 0);
        v7 = strlen((const char *)v5 + 256);
        LOBYTE(a1) = v7 - 1;
        if ( v7 == 1 )
        {
          LOBYTE(a1) = 9;
          v8 = (unsigned __int16)AugmentWeirdValue();
          *(int *)((char *)v5 + 261) = (AugmentWeirdValue() << 16) | v8;
        }

        v21 += a1;
        WriteFile(hFile, &a1, 1u, &NumberOfBytesWritten, 0);
        WriteFile(hFile, (char *)v5 + 256, (unsigned __int8)a1, &NumberOfBytesWritten, 0);
        v17 = i + *((int *)v5 + 129);
        v15 = *(int *)(v5 + (unsigned __int8)a1 + 251);
        v10 = __ROL__(v15 ^ v17, v21);
        v17 = ~v10;
        WriteFile(hFile, &v17, 4u, &NumberOfBytesWritten, 0);
        WriteFile(hFile, (char *)v5 + 520, 1u, &NumberOfBytesWritten, 0);
        WriteFile(hFile, (char *)v5 + 521, 4u, &NumberOfBytesWritten, 0);
        v1 = 0;
      }
    }
  }

  CloseHandle(hFile);
  return 1;
}





int main(int argc, char *argv[])
{
    if (argc < 2)
        return -1;

    HANDLE hFile = CreateFile(argv[1], GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
    if ( hFile == INVALID_HANDLE_VALUE )
    {
        fprintf(stderr, "Could not open \"%s\".\n", argv[1]);
        return 1;
    }

    if (LoadPlaylist(hFile))
        fprintf(stderr, "\"%s\" is invalid.\n", argv[1]);

    CloseHandle(hFile);

    return 0;
}
